MEMORY {
	FLASH(rx) : ORIGIN = 0x10000000, LENGTH = 2048k
	SRAM(rwx) : ORIGIN = 0x20000100, LENGTH = 256k - 256
}

SECTIONS {

		 .boot2 : {
				*(.boot2);
		 } > FLASH

		 .crt0 : {
				*(.crt0);
		 } > FLASH

		 __vector_table_start__ = .;
		 .vector_table : {
				*(.vector_table);
		 } > FLASH

		 .text ALIGN(2) : {
				 *(.text)
		 } > FLASH

		 .data : {
			 *(.text)
		 } > SRAM AT> FLASH
		 __data_src__ = LOADADDR(.data);
		 __data_dst__ = ORIGIN(SRAM);
		 __data_size__ = SIZEOF(.data);

		 .bss : {
				 __bss_start__ = .;
				 *(.bss)
		 } > SRAM
		 __bss_size__ = SIZEOF(.bss);
}
