#ifndef __BITMAP_H__
#define __BITMAP_H__

#define _BIT(BIT) (1u << (BIT))

// ----- USB Controller -----
// INTS
#define BIT_USBCTRL_INTS_SETUP_REQ _BIT(16)
#define BIT_USBCTRL_INTS_BUFFER_STATUS _BIT(4)
#define BIT_USBCTRL_INTS_TRANS_COMPLETE _BIT(3)
#define BIT_USBCTRL_INTS_BUS_RESET _BIT(12)
// SIE_STATUS
#define BIT_USBCTRL_SIE_STATUS_SETUP_REC _BIT(17)
#define BIT_USBCTRL_SIE_STATUS_BUS_RESET _BIT(19)
// Buffer control
#define BIT_USBCTRL_BUFFER0_PID _BIT(13)
#define BIT_USBCTRL_BUFFER0_FULL _BIT(15)
#define BIT_USBCTRL_BUFFER0_AVAILABLE _BIT(10)
#define MASK_USBCTRL_BUFFER0_LENGTH (0x3ff)
// Muxing
#define BIT_USBCTRL_MUXING_TO_PHY _BIT(0)
#define BIT_USBCTRL_MUXING_SOFTCON _BIT(3)
// Power
#define BIT_USBCTRL_PWR_VBUS_DETECT _BIT(2)
#define BIT_USBCTRL_PWR_VBUS_DETECT_OVERRIDE_EN _BIT(3)
// SIE_CTRL
#define BIT_USBCTRL_SIE_CTRL_PULLUP_EN _BIT(16)
#define BIT_USBCTRL_SIE_CTRL_PULLDOWN_EN _BIT(15)
#define BIT_USBCTRL_SIE_CTRL_EP0_INT_1BUF _BIT(29)
// MAIN_CTRL
#define BIT_USBCTRL_MAIN_CTRL_CONTROLLER_EN _BIT(0)
#define BIT_USBCTRL_MAIN_CTRL_HOST_NDEVICE _BIT(1)
// INTE
#define BIT_USBCTRL_INTE_SETUP_REQ _BIT(16)
#define BIT_USBCTRL_INTE_BUS_RESET _BIT(12)
#define BIT_USBCTRL_INTE_BUFF_STATUS _BIT(4)
// Endpoint Control
#define BIT_USBCTRL_ENDP_CTRL_ENABLE _BIT(31)
#define BIT_USBCTRL_ENDP_CTRL_INT_PER_BUFF1 _BIT(29)
#define BIT_USBCTRL_ENDP_CTRL_TYPE_LSB (26)

#endif
